# Code generated by smithy-python-codegen DO NOT EDIT.

from dataclasses import dataclass
from typing import ClassVar, Literal

from smithy_core.documents import Document
from smithy_core.exceptions import SmithyException

from .models import ValidationExceptionField


class ServiceError(SmithyException):
    """Base error for all errors in the service."""

    pass


@dataclass
class ApiError(ServiceError):
    """Base error for all API errors in the service."""

    code: ClassVar[str]
    fault: ClassVar[Literal["client", "server"]]

    message: str

    def __post_init__(self) -> None:
        super().__init__(self.message)


@dataclass
class UnknownApiError(ApiError):
    """Error representing any unknown api errors"""

    code: ClassVar[str] = "Unknown"
    fault: ClassVar[Literal["client", "server"]] = "client"


@dataclass(kw_only=True)
class DataValidationException(ApiError):
    """ValidationException with data.
    :param message: A message associated with the specific error.

    """

    code: ClassVar[str] = "DataValidationException"
    fault: ClassVar[Literal["client", "server"]] = "client"

    message: str
    field_list: list[ValidationExceptionField] | None = None
    data: Document | None = None


@dataclass(kw_only=True)
class NoSuchResource(ApiError):
    """The resource on which an operation was executed does not exist.
    :param message: A message associated with the specific error.

    """

    code: ClassVar[str] = "NoSuchResource"
    fault: ClassVar[Literal["client", "server"]] = "client"

    message: str
    resource_type: str


@dataclass(kw_only=True)
class Unauthorized(ApiError):
    """The user is not authorized to perform the operation.
    :param message: A message associated with the specific error.

    """

    code: ClassVar[str] = "Unauthorized"
    fault: ClassVar[Literal["client", "server"]] = "client"

    message: str


@dataclass(kw_only=True)
class UnexpectedServerError(ApiError):
    """The operation has error out due to unexpected reasons.

    This could be due to the
    current state of the resource, or one of the
    request parameters of the operation
    or missing permission.
    :param message: A message associated with the specific error.

    """

    code: ClassVar[str] = "UnexpectedServerError"
    fault: ClassVar[Literal["client", "server"]] = "server"

    message: str


@dataclass(kw_only=True)
class ValidationException(ApiError):
    """A standard error for input validation failures.
    This should be thrown by
    services when a member of the input structure
    falls outside of the modeled or
    documented constraints.
    :param message: A message associated with the specific error.

    :param field_list: A list of specific failures encountered while validating the
    input.
    A member can appear in this list more than once if it failed to satisfy
    multiple constraints.
    """

    code: ClassVar[str] = "ValidationException"
    fault: ClassVar[Literal["client", "server"]] = "client"

    message: str
    field_list: list[ValidationExceptionField] | None = None


@dataclass(kw_only=True)
class NotAllowed(ApiError):
    """The operation not is not allowed.

    This could be due to the current state of the
    resource, or one of the
    request parameters of the operation.
    :param message: A message associated with the specific error.

    """

    code: ClassVar[str] = "NotAllowed"
    fault: ClassVar[Literal["client", "server"]] = "client"

    message: str
